"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HelperUtilsComponent = void 0;
const typedoc_1 = require("typedoc");
const components_1 = require("typedoc/dist/lib/output/components");
const theme_1 = require("../theme");
let HelperUtilsComponent = class HelperUtilsComponent extends components_1.ContextAwareRendererComponent {
    initialize() {
        super.initialize();
        const component = this;
        theme_1.default.HANDLEBARS.registerHelper('relativeURL', (url) => {
            return url
                ? this.publicPath
                    ? this.publicPath + url
                    : this.getRelativeUrl(url)
                : url;
        });
        theme_1.default.HANDLEBARS.registerHelper('ifShowNamedAnchors', function (options) {
            return component.namedAnchors ? options.fn(this) : options.inverse(this);
        });
        theme_1.default.HANDLEBARS.registerHelper('ifShowBreadcrumbs', function (options) {
            return component.hideBreadcrumbs
                ? options.inverse(this)
                : options.fn(this);
        });
        theme_1.default.HANDLEBARS.registerHelper('ifShowSources', function (options) {
            return component.hideSources ? options.inverse(this) : options.fn(this);
        });
        theme_1.default.HANDLEBARS.registerHelper('ifShowProjectName', function (options) {
            return component.hideProjectName
                ? options.inverse(this)
                : options.fn(this);
        });
    }
};
__decorate([
    typedoc_1.BindOption('publicPath')
], HelperUtilsComponent.prototype, "publicPath", void 0);
__decorate([
    typedoc_1.BindOption('namedAnchors')
], HelperUtilsComponent.prototype, "namedAnchors", void 0);
__decorate([
    typedoc_1.BindOption('hideProjectName')
], HelperUtilsComponent.prototype, "hideProjectName", void 0);
__decorate([
    typedoc_1.BindOption('hideBreadcrumbs')
], HelperUtilsComponent.prototype, "hideBreadcrumbs", void 0);
__decorate([
    typedoc_1.BindOption('hideSources')
], HelperUtilsComponent.prototype, "hideSources", void 0);
HelperUtilsComponent = __decorate([
    components_1.Component({ name: 'utils' })
], HelperUtilsComponent);
exports.HelperUtilsComponent = HelperUtilsComponent;
